(function () {

    'use strict';

    function runGame (gameName,data) {
        //wanba begin
        console.log("on startGame");
        var gameRoot = gameName +"/";

        console.log("require settings.js ...");
        require(gameName +'/src/settings.js');
        //wanba end

        var settings = window._CCSettings;
        window._CCSettings = undefined;

        if ( !settings.debug ) {
            // retrieve minified raw assets
            var rawAssets = settings.rawAssets;
            var assetTypes = settings.assetTypes;
            for (var mount in rawAssets) {
                var entries = rawAssets[mount];
                for (var uuid in entries) {
                    var entry = entries[uuid];
                    var type = entry[1];
                    if (typeof type === 'number') {
                        entry[1] = assetTypes[type];
                    }
                }
            }
        }

        console.log("init onStart ...");
        var onStart = function () {
            cc.view.resizeWithBrowserSize(true);
            // UC browser on many android devices have performance issue with retina display
            if (cc.sys.os !== cc.sys.OS_ANDROID || cc.sys.browserType !== cc.sys.BROWSER_TYPE_UC) {
                cc.view.enableRetina(true);
            }
            //cc.view.setDesignResolutionSize(settings.designWidth, settings.designHeight, cc.ResolutionPolicy.SHOW_ALL);

            if (cc.sys.isMobile) {
                if (settings.orientation === 'landscape') {
                    cc.view.setOrientation(cc.macro.ORIENTATION_LANDSCAPE);
                }
                else if (settings.orientation === 'portrait') {
                    cc.view.setOrientation(cc.macro.ORIENTATION_PORTRAIT);
                }
                // qq, wechat, baidu
                cc.view.enableAutoFullScreen(
                    cc.sys.browserType !== cc.sys.BROWSER_TYPE_BAIDU &&
                    cc.sys.browserType !== cc.sys.BROWSER_TYPE_WECHAT &&
                    cc.sys.browserType !== cc.sys.BROWSER_TYPE_MOBILE_QQ
                );
            }

            console.log("init AssetLibrary ...");
            // init assets
            cc.AssetLibrary.init({
                libraryPath: gameRoot +'res/import',
                rawAssetsBase: gameRoot + 'res/raw-',
                rawAssets: settings.rawAssets,
                packedAssets: settings.packedAssets
            });

            console.log("notification js game start game ...");
            cc.director.notificationJsGame("COCOS_GAME_START",data);
        };

        require(gameName +'/src/project.js');
        console.log("require project.js finish ...");

        var option = {
            //width: width,
            //height: height,
            id: 'GameCanvas',
            scenes: settings.scenes,
            debugMode: settings.debug ? cc.DebugMode.INFO : cc.DebugMode.ERROR,
            showFPS: false,
            frameRate: 30,
            jsList: [],
            groupList: settings.groupList,
            collisionMatrix: settings.collisionMatrix,
            renderMode: 0
        };

        cc.game.run(option, onStart);
    }

    console.log("init flags ...");
    cc.flag_blend_fix = false; //fix blend func
    cc.flag_download_fix = true;
    cc.flag_close_log = true;
    cc.flag_show_version = false;

    if (cc.flag_close_log) {
        console.log = function() {};
    }

    console.log("init search path ...");
    var oldSearchPaths = jsb.fileUtils.getSearchPaths();
    var newSearchPaths = [ oldSearchPaths, jsb.fileUtils.getWritablePath()];

    for(var i = 0 ; i< newSearchPaths.length;i++){
        console.log("add path:"+newSearchPaths[i]);
    }
    jsb.fileUtils.setSearchPaths(newSearchPaths);


    console.log("require jsb_polyfill.js ...");
    require('src/jsb_polyfill.js');

    console.log("require Fetch.js...");
    require('src/Fetch.js');

    console.log("require native.js ...");
    require('src/native.js');


    cc.classConstructors = {};

    cc.setConstructors = function(id,constructor){
        cc.classConstructors[id] = constructor;
        console.log("RegistConstructor:", id);
    }
    cc.unSetConstructors = function(){
        for(var key in cc.classConstructors){
            console.log("UnRegistConstructor:", key);
            cc.js.unregisterClass(cc.classConstructors[key]);
        }
        cc.classConstructors = {};
    }

    console.log("init notificationNative ...",cc.sys.os);
    if (cc.sys.os === cc.sys.OS_ANDROID) {
        cc.director.notificationNative = function (eventName, data) {
            jsb.reflection.callStaticMethod("com/wodi/who/activity/CocosGameActivity", "notificationNative", "(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;", eventName, data);
        }
    } else if (cc.sys.os === cc.sys.OS_IOS) {
        cc.director.notificationNative = jsb.reflection.callStaticMethod;
    }

    console.log("init notificationJs ...");
    cc.director.notificationJs = function(eventName, data) {
        console.log("notificationJs", eventName, data);
        var data = JSON.parse(data);

        console.log("gameName is ", data.gameName);

        if (eventName == "COCOS_GAME_START") {
            console.log("cc.director.notificationJs COCOS_GAME_START," + data.gameName);
            runGame(data.gameName, data);
        } else {
            if (cc.director.notificationJsGame) {
                cc.director.notificationJsGame(eventName, data);
            } else {
                console.log("cc.director.notificationJsGame is null");
            }
        }
    }

    if (cc.sys.os === cc.sys.OS_ANDROID && cc.director.notificationNative) {
        cc.director.notificationNative("COCOS_ANDROID_LOADED", "{}");
    }


    // startGame();

    __errorHandler = function(a,b,c){
        if(!cc.remoteLogCooldown || (cc.remoteLogCooldown < new Date().getTime() - 5000)){
            cc.remoteLogCooldown = new Date().getTime();
            console.log("remoteLogCooldown",cc.remoteLogCooldown)
            cc.native.remoteLog({
                game_name:cc.gameName,
                cocos_event:"onCocosError",
                errorFile:a,
                errorLine:b,
                errorType:c,
            });
        }
    }

})();
