
var Native = cc.Class({
    //退出游戏
    quitGame:function(liveVoiceOpened,liveVoiceRoomId){
        console.log("native","quitGame");
        if(cc.director.notificationNative){

            this.onQuitGame();
            //TODO
            cc.director.notificationNative("COCOS_GAME_QUIT",JSON.stringify(
                liveVoiceOpened === undefined ? {}:
                {
                    liveVoiceOpened:liveVoiceOpened,
                    liveVoiceRoomId:liveVoiceRoomId
                }
            ));
        }
    },
    //退出游戏
    backRoom:function(roomId){
        console.log("native","backRoom");
        if(cc.director.notificationNative){

            this.onQuitGame();
            //TODO
            cc.director.notificationNative("COCOS_BACK_ROOM",JSON.stringify({
                roomId:roomId,
            }));
        }
    },

    //换房间 Id
    changeRoomId:function(roomId){
        console.log("native","changeRoomId");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_CHANGE_ROOM_ID",JSON.stringify({
                roomId:roomId,
            }));
        }
    },

    //弹出用户信息界面
    showUserInfoView:function(userId,avatarUrl){
        console.log("native","showUserInfoView",userId);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_VIEW_USER_INFO",JSON.stringify({
                userId:userId,
                userIcon:avatarUrl,
            }));
        }
    },

    //@一个用户
    atUser:function(userName){
        console.log("native","atUser",userName);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_INPUT_TEXT",JSON.stringify({
                text:userName
            }));
        }
    },

    // native.showRose("pink",13,3);
    showRose:function(file,rate,during){
        console.log("native","showRose",file,rate,during);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_EFFECT_SHOW_ROSE",JSON.stringify({
                file:file,
                rate:rate,
                during:during,
            }));
        }
    },

    //弹出充值界面
    showRechargeView:function(gameName){
        console.log("native","showRechargeView",gameName);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_VIEW_RECHARGE",JSON.stringify({
                gameName:gameName,
            }));
        }
    },

    //弹出排行榜界面
    showRankView:function(gameName){
        console.log("native","showRankView",gameName);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_VIEW_RANK",JSON.stringify({
                gameName:gameName,
            }));
        }
    },

    //弹出排行榜界面
    showHistoryView:function(gameName){
        console.log("native","showHistoryView",gameName);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_VIEW_HISTORY",JSON.stringify({
                gameName:gameName,
            }));
        }
    },

    //帮助界面
    showHelpView:function(gameName,url,title){
        console.log("native","showHelpView",gameName);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_VIEW_HELP",JSON.stringify({
                gameName:gameName,
                url:url,
                title:title,
            }));
        }
    },

    showRoomSettingView:function(roomId){
        console.log("native","showRoomSettingView",roomId);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_SHOW_ROOM_SETTING",JSON.stringify({
                roomId:roomId,
            }));
        }
    },

    //弹出提示
    showAlertView:function(context,btnText,title){
        console.log("native","showAlertView",context,btnText,title);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_VIEW_ALERT",JSON.stringify({
                context:context,
                btnText:btnText,
                title:title,
            }));
        }
    },

    //弹出提示
    showToastView:function(text){
        console.log("native","showToastView",text);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_VIEW_TOAST",JSON.stringify({
                text:text,
            }));
        }
    },

    //发mqtt
    sendMqtt:function(gameName,cmd,data){
        console.log("native","sendMqtt",data);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_MQTT_SEND",JSON.stringify({
                topic:"/"+gameName+"/c2s",
                cmd:cmd,
                message:JSON.stringify(data),
            }));
        }
    },

    sendMqttCm:function(gameName,cmd,data){
        console.log("native","sendMqtt",data);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_MQTT_SEND_COMMON",JSON.stringify({
                topic:"/"+gameName+"/c2c",
                cmd:cmd,
                message:JSON.stringify(data),
            }));
        }
    },

    //Cocos报错提交日志 和 打点接口
    remoteLog:function(params){
        console.log("native","remoteLog");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_REMOTE_LOG",JSON.stringify({
                params:JSON.stringify(params || {}),
            }));
        }
    },

    //点歌
    showPlayMusic:function(){
        console.log("native","showPlayMusic");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_SHOW_PLAY_MUSIC",JSON.stringify({}));
        }
    },

    //音效音乐接口 和 声网语音大小控制
    roomSoundSwitch:function(data){
        console.log("native","roomSoundSwitch",JSON.stringify(data));
        data = data || {};
        data.liveSwitch = data.liveSwitch || 0;//实时语音开关
        data.liveVol = data.liveVol || 0;//0-100 ? 实时语音音量
        data.musicSwitch = data.musicSwitch ||  0;//1-0 音乐开关
        data.musicVol = data.musicVol ||  0;//0-100 ? 音乐音量
        data.effectSwitch = data.effectSwitch ||  0;//1-0 音效开关

        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_ROOM_SOUND_SWITCH",JSON.stringify({
                data : JSON.stringify( data ),
            }));
        }
    },

    //音效开关
    onRoomSoundSwitchToJs:function(data){
        console.log("native","onRoomSoundSwitchToJs",data);
        cc.soundSwitch = data;

        for(var i = 0 ; i < this.listeners.length;i++){
            if(this.listeners[i].onRoomSoundSwitchToJs){
                this.listeners[i].onRoomSoundSwitchToJs(data);
            }
        }
    },

    //订阅mqtt
    mqttSubscribePrivate:function(topic,cmd){
        console.log("native","mqttSubscribePrivate",topic,cmd);
        if(cc.director.notificationNative){
            console.log("native","mqttSubscribePrivate",topic);

            this.topicPtMap = this.topicPtMap || {};
            this.topicPtMap[topic] = cmd;//同topic注销多次原生会报错,这里只保存一个
            cc.director.notificationNative("COCOS_MQTT_SUBSCRIBE_PRIVATE",JSON.stringify({
                topic:topic,
                cmd:cmd,
            }));
        }
    },

    //订阅mqtt
    mqttSubscribeCommon:function(topic,cmd){
        console.log("native","mqttSubscribeCommon",topic,cmd);
        if(cc.director.notificationNative){
            this.topicCmMap = this.topicCmMap || {};
            this.topicCmMap[topic] = cmd;//同topic注销多次原生会报错,这里只保存一个
            cc.director.notificationNative("COCOS_MQTT_SUBSCRIBE_COMMON",JSON.stringify({
                topic:topic,
                cmd:cmd,
            }));
        }
    },

    //退订阅mqtt
    mqttUnsubscribePrivate:function(topic,cmd){
        console.log("native","mqttUnsubscribePrivate",topic);
        if(cc.director.notificationNative){
            this.topicPtMap = this.topicPtMap || {};
            this.topicPtMap[topic] = undefined;//同topic注销多次原生会报错,这里只保存一个
            cc.director.notificationNative("COCOS_MQTT_UNSUBSCRIBE_PRIVATE",JSON.stringify({
                topic:topic,
                cmd:cmd,
            }));
        }
    },

    //退订阅mqtt
    mqttUnsubscribeCommon:function(topic,cmd){
        console.log("native","mqttUnsubscribeCommon",topic);
        if(cc.director.notificationNative){
            this.topicCmMap = this.topicCmMap || {};
            this.topicCmMap[topic] = undefined;//同topic注销多次原生会报错,这里只保存一个
            cc.director.notificationNative("COCOS_MQTT_UNSUBSCRIBE_COMMON",JSON.stringify({
                topic:topic,
                cmd:cmd,
            }));
        }
    },

    //发http
    sendHttp:function(url,data){
        console.log("native","sendHttp",url,data);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_HTTP_POST",JSON.stringify({
                path:url,
                param: data || {} ,
            }));
        }
    },

    //设置实时语音麦克开关
    liveVoiceEnableSpeaker:function(enable){
        console.log("native", "liveVoiceEnableSpeaker");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_LIVE_VOICE_ENABLE_SPEAKER", JSON.stringify(
                    {
                        enable:enable,
                    }
                )
            );
        }
    },

    //设置禁止听所有用户的语音
    liveVoiceBanAll:function(ban){
        console.log("native", "liveVoiceBanAll");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_LIVE_VOICE_BAN_ALL", JSON.stringify(
                    {
                        ban:ban,
                    }
                )
            );
        }
    },

    //设置禁止听某一个用户的语音
    liveVoiceBanAll:function(uid,ban){
        console.log("native", "liveVoiceBanByUid");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_LIVE_VOICE_BAN_UID", JSON.stringify(
                    {
                        uid:uid,
                        ban:ban,
                    }
                )
            );
        }
    },

    //设置实时语音进入房间
    liveVoiceJoinRoom:function(roomId, interval){
        console.log("native", "liveVoiceJoinRoom");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_LIVE_VOICE_JOIN_ROOM", JSON.stringify(
                    {
                        roomId:roomId,
                        interval:interval,
                    }
                )
            );
        }
    },

     //设置实时语音退出房间
    liveVoiceQuitRoom:function(roomId, liveVoiceOpened){
        console.log("native", "liveVoiceQuitRoom");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_LIVE_VOICE_QUIT_ROOM", JSON.stringify(
                    {
                        roomId:roomId,
                        liveVoiceOpened:liveVoiceOpened
                    }
                )
            );
        }
    },

    //切换语音房间
    liveVoiceChangeRoom:function(roomId){
    console.log("native", "liveVoiceChangeRoom");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_LIVE_VOICE_CHANGE_ROOM", JSON.stringify(
                    {
                        roomId:roomId,
                    }
                )
            );
        }
    },

    //显示聊天
    showRoomChat:function(channel,clean){
        console.log("native","showRoomChat",channel,clean);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_SHOW_ROOM_CHAT",JSON.stringify({
                channel:channel || 0,
                clean:clean || 0,
            }));
        }
    },

    //显示聊天
    hideRoomChat:function(roomId){
        console.log("native","hideRoomChat");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_HIDE_ROOM_CHAT",JSON.stringify({}));
        }
    },

    //邀请好友
    inviteFirend:function(){
        console.log("native","inviteFirend");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_SHOW_ROOM_INVITE_FRIEND",JSON.stringify({}));
         }
    },

    //邀请好友
    showShare:function(jsonData){
            console.log("native","share");
            if(cc.director.notificationNative){
                cc.director.notificationNative("COCOS_SHOW_SHARE",JSON.stringify(jsonData));
          }
    },

    //显示键盘
    showKeyboard:function(channel,clean){
        console.log("native","showKeyboard",channel,clean);
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_SHOW_KEYBOARD",JSON.stringify({
                channel:channel || 0,
                clean:clean || 0,
            }));
        }
    },

    //隐藏键盘
    hideKeyboard:function(){
        console.log("native","hideKeyboard");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_HIDE_KEYBOARD",JSON.stringify({}));
        }
    },

    //隐藏加载界面
    hideLoading:function(){
        console.log("native","hideLoading");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_HIDE_LOADING",JSON.stringify({}));
        }
          if (cc.flag_show_version){
              var versionfile = JSON.parse(jsb.fileUtils.getStringFromFile(cc.gameName +'/version.json'));
              var version = versionfile["version"];
              cc.native.showToastView("Version:" + version);
          }
    },

    //调出礼物面板
    showGiftPanel:function(data){
        console.log("native","showGiftPanel");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_GIFT_PANEL_SHOW",JSON.stringify({
                data:JSON.stringify(data),
            }));
        }
    },

    //关闭礼物面板
    closeGiftPanel:function(){
        console.log("native","closeGiftPanel");
        if(cc.director.notificationNative){
            cc.director.notificationNative("COCOS_GIFT_PANEL_CLOSE",JSON.stringify({}));
        }
    },

    init:function () {
        this.listeners = [];
        this.registered = false;
        this.register();
        return this;
    },

    //注册监听 所有原生调js的接口
    register: function register() {
        console.log("native", "register1");
        if (!this.registered) {
            this.registered = true;
            console.log("native", "register2");

            var that = this;

            cc.director.notificationJsGame = function (eventName, data) {
                console.log("cc.director.notificationJsGame", eventName);
//                cc.director.getScheduler().schedule(
//                    function(){
                        if (eventName == "COCOS_GAME_START") {

                            var gameName = data.gameName;
                            var uid = data.uid;
                            var avatar = data.avatar;

                            cc.uid = uid;
                            cc.matchId = data.matchId;
                            cc.avatar = avatar;
                            cc.gameName = gameName;
                            cc.name = data.name;
                            cc.roomId = data.roomId;
                            cc.soundOn = data.soundOn;
                            cc.mqttTopic = data.mqttTopic;
                            cc.soundSwitch = {
                                liveSwitch: data.liveSwitch || 0,
                                liveVol: data.liveVol || 0,
                                musicSwitch: data.musicSwitch || 0,
                                musicVol: data.musicVol || 0,
                                effectSwitch: data.effectSwitch || 0,
                            };
                            cc.ext = data.ext && JSON.parse(data.ext);

                            cc.director.loadScene('main', function () {

                            });
                        } else if (eventName == "MQTT_COMMON_RECEIVED") {
                            that.onCommonMqttMsg(data);
                        } else if (eventName == "MQTT_PRIVATE_RECEIVED") {
                            that.onPrivateMqttMsg(data);
                        } else if (eventName == "HTTP_RESPONSE") {
                            that.onHttpResponse(data);
                        } else if (eventName == "COCOS_GAME_MQTT_ERROR") {
                            that.onMqttError(data);
                        } else if (eventName == "COCOS_GAME_RESUME") {
                            that.onGameResume(data);
                        } else if (eventName == "COCOS_GAME_STOP") {
                            that.onGameStop(data);
                        } else if (eventName == "COCOS_GAME_RECHARGE_SUCCESS") {
                            that.onRechargeSuccess(data);
                        } else if (eventName == "COCOS_GAME_MQTT_STATE_CHANGE") {
                            that.onMqttStateChange(data);
                        } else if (eventName == "ROOM_SOUND_SWITCH_ON") {
                            data.soundOn = true;
                            that.onRoomSoundSwitch(data);
                        } else if (eventName == "ROOM_SOUND_SWITCH_OFF") {
                            data.soundOn = false;
                            that.onRoomSoundSwitch(data);
                        } else if (eventName == "COCOS_ROOM_SOUND_SWITCH_TO_JS") {
                            that.onRoomSoundSwitchToJs(data);

                        } else if (eventName == "COCOS_ROOM_CHAT") {
                            that.onRoomChat(data);
                        } else if (eventName == "COCOS_LIVE_VOICE_VOLUME"){
                            that.onLiveVoiceVolume(data);
                        } else if (eventName == "COCOS_GAME_EXCHANGE") {
                            that.onExchange(data);
                        } else if (eventName == "COCOS_GAME_KEYBOARD_INPUT") {
                            that.onKeyboardInput(data);

                        } else if (eventName == "COCOS_USERINFO_PANEL_CLOSE"){
                            that.onUserInfoPanelClose(data);
                        }
//                    },that,0,0,0);
                

            //mqtt收消息

            //TODO
            }
        }
    },

    onQuitGame:function(){
        console.log("native","onQuitGame");

        //退出游戏时,自动注销所有topic
        for(var topic in this.topicCmMap){
            this.mqttUnsubscribeCommon(topic,this.topicCmMap[topic]);
        }

        for(var topic in this.topicPtMap){
            this.mqttUnsubscribePrivate(topic,this.topicPtMap[topic]);
        }
        this.topicCmMap = [];
        this.topicPtMap = [];

        cc.unSetConstructors();
        cc.loader.releaseAll();
        cc.sys.cleanScript(cc.gameName + "/src/project.js");
        cc.sys.cleanScript(cc.gameName + "/src/setting.js");
        cc.sys.garbageCollect();

    },

    //注销原生监听
    unregister:function(){
        cc.director.notificationJsGame = null;
    },

    //收到mqtt消息
    onCommonMqttMsg:function(data){
        console.log("native","onCommonMqttMsg",(data));

        var message = JSON.parse(data.message);
        message.body = message.body || {};
        message.body.cmd = message.cmd;
        for(var i = 0 ; i < this.listeners.length;i++){
            this.listeners[i].onMsg(data.topic,message.body,message.desc);
        } 
        
    },

    //音效开关
    onRoomSoundSwitch:function(data){
        console.log("native","onRoomSoundSwitch",(data.soundOn));
        cc.soundOn = data.soundOn;
        for(var i = 0 ; i < this.listeners.length;i++){
            if(this.listeners[i].onRoomSoundSwitch){
                this.listeners[i].onRoomSoundSwitch(data);
            }
        }
    },

    //收到mqtt消息
    onPrivateMqttMsg:function(data){
        console.log("native","onPrivateMqttMsg",(data));

        var message = JSON.parse(data.message);
        message.body = message.body || {};
        message.body.cmd = message.cmd;
        for(var i = 0 ; i < this.listeners.length;i++){
            this.listeners[i].onMsg(data.topic,message.body,message.desc);
        }
    },

    onGameResume:function(data){
        console.log("native","onGameResume",(data));
        for(var i = 0 ; i < this.listeners.length;i++){
            if(this.listeners[i].onResume){
                this.listeners[i].onResume(data);
            }
        } 
    },

    onGameStop:function(data){
        console.log("native","onGameStop",(data));
        for(var i = 0 ; i < this.listeners.length;i++){
            if(this.listeners[i].onGameStop){
                this.listeners[i].onGameStop(data);
            }
        }
    },


    onRechargeSuccess:function(data){
        console.log("native","onRechargeSuccess",(data));
        for(var i = 0 ; i < this.listeners.length;i++){
            if(this.listeners[i].onRechargeSuccess){
                this.listeners[i].onRechargeSuccess(data);
            }
        } 
    },

    onRoomChat:function(data){
        console.log("native","onRoomChat",(data));
        for(var i = 0 ; i < this.listeners.length;i++){
            if(this.listeners[i].onRoomChat){
                this.listeners[i].onRoomChat(data);
            }
        }
    },

    onLiveVoiceVolume:function(data){
        console.log("native","onLiveVoiceVolume",JSON.stringify(data));
        for(var i = 0; i < this.listeners.length; i++){
            if(this.listeners[i].onLiveVoiceVolume){
                this.listeners[i].onLiveVoiceVolume(data);
            }
        }
    },

    onExchange:function(data){
        console.log("native","onExchange");
        for(var i = 0 ; i < this.listeners.length;i++){
            if(this.listeners[i].onExchange){
                this.listeners[i].onExchange(data);
            }
        }
    },

    //输入框游戏频道输入回调
    onKeyboardInput:function(data){
        console.log("native","onKeyboardInput");
        for(var i = 0 ; i < this.listeners.length;i++){
            if(this.listeners[i].onKeyboardInput){
                this.listeners[i].onKeyboardInput(data);
            }
        }
    },

    //mqtt错误
    onMqttError:function(err){
        console.log("native","onMqttError");
        this.showToastView("网络断开了");
        
        //TODO MQTT_ERROR
        
    },

    //mqtt重连
    onMqttStateChange:function(data){
        console.log("native","onMqttStateChange");
        if(data.connected){
            this.showToastView("网络恢复了");
            for(var i = 0 ; i < this.listeners.length;i++){
                if(this.listeners[i].onMqttStateChange){
                    this.listeners[i].onMqttStateChange(data);
                }
            } 
        }
    },



    //http回调
    onHttpResponse:function(data){
        console.log("native","onHttpResponse",data);

        
        //TODO HTTP_RESPONSE
        
    },

    //回调关闭cocos个人信息面板
    onUserInfoPanelClose:function(data){
        console.log("native","onUserInfoPanelClose");
        for(var i = 0 ; i < this.listeners.length;i++){
            if(this.listeners[i].onUserInfoPanelClose){
                this.listeners[i].onUserInfoPanelClose(data);
            }
        }
    },

    addListener:function(listener){
        console.log("mqtt addListener",listener == null);
        this.listeners.push(listener);

    },

    removeListener:function(listener){
        console.log("mqtt removeListener",listener == null);
        this.listeners = [];
    },

    properties: {
        version:5,
    },

});

cc.native = new Native().init();